; Turbo51 version 0.1.3.17, Copyright 2000 - 2013 Igor Funa

$REGISTERBANK (0)

_CODE         SEGMENT  CODE
_DATA         SEGMENT  DATA
_XDATA        SEGMENT  XDATA

              PUBLIC   pin

              EXTRN    DATA  (SystemIO)
              EXTRN    DATA  (CurrentIO)
              EXTRN    DATA  (R8)
              EXTRN    DATA  (R9)
              EXTRN    IDATA (StackStart)
              EXTRN    BIT   (LastCharacterBufferValid)

              EXTRN    CODE  (sysDummyProcedure)
              EXTRN    CODE  (sysFillMem_XDATA)
              EXTRN    CODE  (sysADD_DPTR_A)
              EXTRN    CODE  (sysCopyFrom_XDATA_To_XDATA)
              EXTRN    CODE  (sysWriteStr_XDATA)
              EXTRN    CODE  (sysWriteLine)
              EXTRN    CODE  (sysReadStr_XDATA)
              EXTRN    CODE  (sysReadLine)

; {
; cls
; ..\turbo51\turbo51 -A -B -G %~nx0
; pause
; del *.csv *.u51
; exit
; }
; 
; {$m 0, 10240, 0, 1024, 0}
; {$idata}
; 
; uses time, usb, uart, spi, touch, ws2812;
              EXTRN    DATA  (ms999)
              EXTRN    DATA  (s)

              EXTRN    CODE  (time)
              EXTRN    CODE  (poll)
              EXTRN    CODE  (us)

              EXTRN    DATA  (len)
              EXTRN    XDATA (buf)

              EXTRN    CODE  (usb)
              EXTRN    CODE  (poll)

              EXTRN    CODE  (uart)
              EXTRN    CODE  (poll)
              EXTRN    CODE  (lf)

              EXTRN    DATA  (r)
              EXTRN    DATA  (g)
              EXTRN    DATA  (b)

              EXTRN    CODE  (ws2812)
              EXTRN    CODE  (reset)
              EXTRN    CODE  (rgb)

; var
;     led        : boolean absolute p3.2;
led                             BIT      P3.2

;     ws2812.pin : boolean absolute p1.6;
pin                             BIT      P1.6

; 
;     m1t : record s, us, usmax : word; end absolute usb.buf[1].t;
m1t                             EQU      buf+64

;     m2t : array [1..20] of record r, g, b : byte; end absolute usb.buf[2].t;
m2t                             EQU      buf+192

;     m3r : string[63] absolute usb.buf[3].r;
m3r                             EQU      buf+256

;     m3t : string[63] absolute usb.buf[3].t;
m3t                             EQU      buf+320

; 
;     i : byte;

RSEG _DATA

i:                              DS       1

;     us : word;
us:                             DS       2


CSEG AT $0000

              AJMP     PROGRAM


RSEG _CODE

PROGRAM:
; 
; begin
              MOV       SP, #StackStart-1
              MOV       SystemIO, #LOW  (sysDummyProcedure)
              MOV       SystemIO+1, #HIGH (sysDummyProcedure)
              MOV       SystemIO+2, #LOW  (sysDummyProcedure)
              MOV       SystemIO+3, #HIGH (sysDummyProcedure)
              CLR       LastCharacterBufferValid
              LCALL     time
              LCALL     usb
              LCALL     uart
              LCALL     ws2812

;     fillchar( m2t, 60, 1 );
              MOV       R2, #LOW  ($003C)
              MOV       R3, #HIGH ($003C)
              MOV       R1, #1
              MOV       DPTR, #buf+192
              LCALL     sysFillMem_XDATA

; 
;     repeat
L_008C:
;         time.poll;
              LCALL     poll

;         usb.poll;
              LCALL     poll

;         uart.poll;
              LCALL     poll

; 
;         for i := 1 to 2 do begin
              MOV       i, #0
              MOV       R6, #128
              MOV       R7, #64
L_009C:
              INC       i

;             if usb.len[i].r > 0 then begin
              MOV       A, i
              ADD       A, ACC
              ADD       A, #len-2
              MOV       R0, A
              MOV       A, @R0
              JZ        L_00DE

;                 move( usb.buf[i].r, usb.buf[i].t, 64 );
              MOV       A, i
              MOV       B, R6
              MUL       AB
              ADD       A, #LOW  (buf-128)
              MOV       DPL, A
              MOV       A, B
              ADDC      A, #HIGH (buf-128)
              MOV       DPH, A
              MOV       A, R7
              LCALL     sysADD_DPTR_A
              MOV       R2, DPL
              MOV       R3, DPH
              MOV       A, i
              MOV       B, R6
              MUL       AB
              ADD       A, #LOW  (buf-128)
              MOV       DPL, A
              MOV       A, B
              ADDC      A, #HIGH (buf-128)
              MOV       DPH, A
              MOV       R4, #LOW  ($0040)
              MOV       R5, #HIGH ($0040)
              LCALL     sysCopyFrom_XDATA_To_XDATA

;                 usb.len[i].r := 0;
              MOV       A, i
              ADD       A, ACC
              ADD       A, #len-2
              MOV       R0, A
              MOV       @R0, #0

;             end;
L_00DE:
;             if usb.len[i].t = 0 then usb.len[i].t := 64;
              MOV       A, i
              ADD       A, ACC
              ADD       A, #len-2
              MOV       R0, A
              INC       R0
              CJNE      @R0, #0, L_00F3
              MOV       A, i
              ADD       A, ACC
              ADD       A, #len-2
              MOV       R0, A
              INC       R0
              MOV       @R0, #$40
L_00F3:

;         end;
              MOV       A, i
              CJNE      A, #2, L_009C

; 
;         if usb.len[3].r > 0 then begin
              MOV       A, len+4
              JZ        L_0110

;             writeln( m3r );
              MOV       CurrentIO, SystemIO
              MOV       CurrentIO+1, SystemIO+1
              MOV       DPTR, #buf+256
              MOV       R6, #0
              LCALL     sysWriteStr_XDATA
              LCALL     sysWriteLine

;             usb.len[3].r := 0;
              MOV       len+4, #0

;         end;
L_0110:
;         if (usb.len[3].t = 0) and uart.lf then begin
              MOV       A, len+5
              JNZ       L_0131
              LCALL     lf
              JNC       L_0131

;             readln( m3t );
              MOV       CurrentIO+2, SystemIO+2
              MOV       CurrentIO+3, SystemIO+3
              MOV       DPTR, #buf+320
              MOV       R8, #LOW  ($003F)
              MOV       R9, #HIGH ($003F)
              LCALL     sysReadStr_XDATA
              LCALL     sysReadLine

;             usb.len[3].t := 64;
              MOV       len+5, #$40

;         end;
L_0131:
; 
;         ea := false;
              CLR       IE.7

;         if ws2812.reset then begin
              LCALL     reset
              JNC       L_0167

;             ws2812.r := m2t[1].r;
              MOV       DPTR, #buf+192
              MOVX      A, @DPTR
              MOV       r, A

;             ws2812.g := m2t[1].g;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       g, A

;             ws2812.b := m2t[1].b;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       b, A

;             ws2812.rgb;
              LCALL     rgb

;             ws2812.r := m2t[2].r;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       r, A

;             ws2812.g := m2t[2].g;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       g, A

;             ws2812.b := m2t[2].b;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       b, A

;             ws2812.rgb;
              LCALL     rgb

;             ws2812.r := m2t[3].r;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       r, A

;             ws2812.g := m2t[3].g;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       g, A

;             ws2812.b := m2t[3].b;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       b, A

;             ws2812.rgb;
              LCALL     rgb

;         end;
L_0167:
;         ea := true;
              SETB      IE.7

;         
;         led := time.ms999 > 500;
              MOV       A, ms999
              ADD       A, #LOW  (-501)
              MOV       A, ms999+1
              ADDC      A, #HIGH (-501)
              MOV       P3.2, C

; 
;         m1t.s  := time.s;
              MOV       DPTR, #buf+64
              MOV       A, s
              MOVX      @DPTR, A
              INC       DPTR
              MOV       A, s+1
              MOVX      @DPTR, A

;         m1t.us := time.us - us;
              LCALL     us
              MOV       A, R2
              CLR       C
              SUBB      A, us
              MOV       R2, A
              MOV       A, R3
              SUBB      A, us+1
              MOV       R3, A
              INC       DPTR
              MOV       A, R2
              MOVX      @DPTR, A
              INC       DPTR
              MOV       A, R3
              MOVX      @DPTR, A

;         if m1t.us > m1t.usmax then m1t.usmax := m1t.us;
              INC       DPTR
              MOVX      A, @DPTR
              MOV       R2, A
              INC       DPTR
              MOVX      A, @DPTR
              MOV       R3, A
              MOV       DPTR, #buf+66
              MOVX      A, @DPTR
              SETB      C
              SUBB      A, R2
              INC       DPTR
              MOVX      A, @DPTR
              SUBB      A, R3
              JC        L_01AE
              MOV       DPTR, #buf+66
              MOVX      A, @DPTR
              MOV       R2, A
              INC       DPTR
              MOVX      A, @DPTR
              MOV       R3, A
              INC       DPTR
              MOV       A, R2
              MOVX      @DPTR, A
              INC       DPTR
              MOV       A, R3
              MOVX      @DPTR, A
L_01AE:

;         us := us + m1t.us;
              MOV       DPTR, #buf+66
              MOVX      A, @DPTR
              ADD       A, us
              MOV       us, A
              INC       DPTR
              MOVX      A, @DPTR
              ADDC      A, us+1
              MOV       us+1, A

; 
;     until false;
              LJMP      L_008C

; end.

RSEG _CONST


              END

