{
cls
..\turbo51\turbo51 -A -B -G %~nx0
pause
del *.csv *.u51
exit
}

{$m 0, 10240, 0, 1024, 0}
{$idata}

uses time, usb, uart, spi, touch, ws2812;
var
    led        : boolean absolute p3.2;
    ws2812.pin : boolean absolute p1.6;

    m1t : record s, us, usmax : word; end absolute usb.buf[1].t;
    m2t : array [1..20] of record r, g, b : byte; end absolute usb.buf[2].t;
    m3r : string[63] absolute usb.buf[3].r;
    m3t : string[63] absolute usb.buf[3].t;

    i : byte;
    us : word;

begin
    fillchar( m2t, 60, 1 );

    repeat
        time.poll;
        usb.poll;
        uart.poll;

        for i := 1 to 2 do begin
            if usb.len[i].r > 0 then begin
                move( usb.buf[i].r, usb.buf[i].t, 64 );
                usb.len[i].r := 0;
            end;
            if usb.len[i].t = 0 then usb.len[i].t := 64;
        end;

        if usb.len[3].r > 0 then begin
            writeln( m3r );
            usb.len[3].r := 0;
        end;
        if (usb.len[3].t = 0) and uart.lf then begin
            readln( m3t );
            usb.len[3].t := 64;
        end;

        ea := false;
        if ws2812.reset then begin
            ws2812.r := m2t[1].r;
            ws2812.g := m2t[1].g;
            ws2812.b := m2t[1].b;
            ws2812.rgb;
            ws2812.r := m2t[2].r;
            ws2812.g := m2t[2].g;
            ws2812.b := m2t[2].b;
            ws2812.rgb;
            ws2812.r := m2t[3].r;
            ws2812.g := m2t[3].g;
            ws2812.b := m2t[3].b;
            ws2812.rgb;
        end;
        ea := true;
        
        led := time.ms999 > 500;

        m1t.s  := time.s;
        m1t.us := time.us - us;
        if m1t.us > m1t.usmax then m1t.usmax := m1t.us;
        us := us + m1t.us;

    until false;
end.
