unit time;

interface
var
    ms, ms999, s : word;

procedure poll;
function us : word;

implementation
var
    clock_cfg : byte absolute $B9; volatile;
    safe_mod  : byte absolute $A1; volatile;
    b15 : boolean;
    usp : word;

procedure poll;
begin
    while us - usp > 1000 do begin
        usp := usp + 1000;
        ms := ms + 1;
        ms999 := ms999 + 1;
        if ms999 = 1000 then begin
            ms999 := 0;
            s := s + 1;
        end;
    end;
end;

function us; assembler;
asm
@1:
    mov a, th0
    mov r2, tl0
    cjne a, th0, @1
    jnb tf0, @2
    jb acc.7, @2
    clr tf0
    cpl b15
@2:
    mov c, b15
    rrc a
    mov r3, a
    mov a, r2
    rrc a
    mov r2, a
end;

begin
    ms := 0;
    ms999 := 0;
    s := 0;
    usp := 0;
    safe_mod := $55;
    safe_mod := $AA;
    clock_cfg := {osc_en_int 24MHz} $86;
    safe_mod := 0;
    tmod := {t1_m=2 t0_m=1} $21;
    tcon := {tr1 tr0} $50;
end.
