unit touch;

interface
type
    tin = ( reset, tin0, tin1, tin2, tin3, tin4, tin5 );
var
    data : word absolute $C4; volatile;

procedure select ( tin : tin );
function ready : boolean; inline;

implementation
var
    p1_dir_pu : byte absolute $93; volatile;
    tkey_ctrl : byte absolute $C3; volatile;

procedure select;
begin
    case tin of
        reset : p1_dir_pu := $FF;
        tin0  : p1_dir_pu := p1_dir_pu and {p1.0} (not $01);
        tin1  : p1_dir_pu := p1_dir_pu and {p1.1} (not $02);
        tin2  : p1_dir_pu := p1_dir_pu and {p1.4} (not $10);
        tin3  : p1_dir_pu := p1_dir_pu and {p1.5} (not $20);
        tin4  : p1_dir_pu := p1_dir_pu and {p1.6} (not $40);
        tin5  : p1_dir_pu := p1_dir_pu and {p1.7} (not $80);
    end;
    tkey_ctrl := byte( tin ) + {2ms} $10;
end;

function ready;
begin
    result := (tkey_ctrl and {if} $80) <> 0;
end;

end.
