; Turbo51 version 0.1.3.17, Copyright 2000 - 2013 Igor Funa

$REGISTERBANK (0)

_CODE         SEGMENT  CODE
_DATA         SEGMENT  DATA

              PUBLIC   data
              PUBLIC   free
              PUBLIC   mode
              PUBLIC   order
              PUBLIC   prescaler
              PUBLIC   spi0_ck_se
              PUBLIC   spi0_ctrl
              PUBLIC   spi0_setup

              PUBLIC   master

; unit spi;
; 
; interface
; type
;     mode  = ( mode0, mode3, reset );
;     order = ( lsb, msb );
; var
;     data : byte    absolute $F9; volatile;
data                            EQU      $F9

;     free : boolean absolute $FB; volatile;
free                            BIT      $F8.3

; 
; procedure master ( mode : mode; order : order; prescaler : byte );

RSEG _DATA

mode:                           DS       1
order:                          DS       1
prescaler:                      DS       1

; 
; implementation
; var
;     spi0_ck_se : byte absolute $FB; volatile;
spi0_ck_se                      EQU      $FB

;     spi0_ctrl  : byte absolute $FA; volatile;
spi0_ctrl                       EQU      $FA

;     spi0_setup : byte absolute $FC; volatile;
spi0_setup                      EQU      $FC

; 
; procedure master;

USING 0

master:
; begin
;     spi0_ck_se := prescaler;
              MOV       $FB, prescaler

;     case order of
              MOV       R2, order

;         lsb : spi0_setup := {bit_order} 8;
              CJNE      R2, #0, L_000D
              MOV       $FC, #8
              SJMP      L_0013
L_000D:

;         msb : spi0_setup := 0;
              CJNE      R2, #1, L_0013
              MOV       $FC, #0
L_0013:

;     end;
;     case mode of
              MOV       R2, mode

;         mode0 : spi0_ctrl := {mosi_oe sck_oe} $60;
              CJNE      R2, #0, L_001C
              MOV       $FA, #$60
              RET
L_001C:

;         mode3 : spi0_ctrl := {mosi_oe sck_oe mst_clk} $68;
              CJNE      R2, #1, L_0023
              MOV       $FA, #$68
              RET
L_0023:

;         reset : spi0_ctrl := {clr_all} 2;
              CJNE      R2, #2, L_0029
              MOV       $FA, #2
L_0029:

;     end;
; end;
              RET

RSEG _CONST

; 
; end.

              END

