; Turbo51 version 0.1.3.17, Copyright 2000 - 2013 Igor Funa

$REGISTERBANK (0)

_CODE         SEGMENT  CODE
_DATA         SEGMENT  DATA
_BIT          SEGMENT  BIT

              PUBLIC   ms
              PUBLIC   ms999
              PUBLIC   s
              PUBLIC   clock_cfg
              PUBLIC   safe_mod
              PUBLIC   b15
              PUBLIC   usp

              PUBLIC   poll
              PUBLIC   us
              PUBLIC   time

; unit time;
; 
; interface
; var
;     ms, ms999, s : word;

RSEG _DATA

ms:                             DS       2
ms999:                          DS       2
s:                              DS       2

; 
; procedure poll;
; function us : word;
us_Result:                      DS       2

; 
; implementation
; var
;     clock_cfg : byte absolute $B9; volatile;
clock_cfg                       EQU      $B9

;     safe_mod  : byte absolute $A1; volatile;
safe_mod                        EQU      $A1

;     b15 : boolean;

RSEG _BIT

b15:                            DBIT     1

;     usp : word;

RSEG _DATA

usp:                            DS       2

; 
; procedure poll;

USING 0

poll:
; begin
;     while us - usp > 1000 do begin
              SJMP      L_0041
L_0002:

;         usp := usp + 1000;
              MOV       A, usp
              ADD       A, #LOW  ($03E8)
              MOV       usp, A
              MOV       A, usp+1
              ADDC      A, #HIGH ($03E8)
              MOV       usp+1, A

;         ms := ms + 1;
              MOV       A, ms
              ADD       A, #LOW  (1)
              MOV       ms, A
              MOV       A, ms+1
              ADDC      A, #HIGH (1)
              MOV       ms+1, A

;         ms999 := ms999 + 1;
              MOV       A, ms999
              ADD       A, #LOW  (1)
              MOV       ms999, A
              MOV       A, ms999+1
              ADDC      A, #HIGH (1)
              MOV       ms999+1, A

;         if ms999 = 1000 then begin
              MOV       A, ms999
              CJNE      A, #LOW  ($03E8), L_0041
              MOV       A, ms999+1
              CJNE      A, #HIGH ($03E8), L_0041

;             ms999 := 0;
              CLR       A
              MOV       ms999, A
              MOV       ms999+1, A

;             s := s + 1;
              MOV       A, s
              ADD       A, #LOW  (1)
              MOV       s, A
              MOV       A, s+1
              ADDC      A, #HIGH (1)
              MOV       s+1, A

;         end;
;     end;
L_0041:
;     while us - usp > 1000 do begin
              LCALL     us
              MOV       A, R2
              CLR       C
              SUBB      A, usp
              MOV       R2, A
              MOV       A, R3
              SUBB      A, usp+1
              MOV       R3, A
              MOV       A, R2
              ADD       A, #LOW  (-1001)
              MOV       A, R3
              ADDC      A, #HIGH (-1001)
              JC        L_0002

; end;
              RET

; 
; function us; assembler;

us:
; asm
; @1:
L_0056:
;     mov a, th0
              MOV       A, TH0

;     mov r2, tl0
              MOV       R2, TL0

;     cjne a, th0, @1
              CJNE      A, TH0, L_0056

;     jnb tf0, @2
              JNB       TCON.5, L_0067

;     jb acc.7, @2
              JB        ACC.7, L_0067

;     clr tf0
              CLR       TCON.5

;     cpl b15
              CPL       b15

; @2:
L_0067:
;     mov c, b15
              MOV       C, b15

;     rrc a
              RRC       A

;     mov r3, a
              MOV       R3, A

;     mov a, r2
              MOV       A, R2

;     rrc a
              RRC       A

;     mov r2, a
              MOV       R2, A

; end;
              RET


time:
; 
; begin
;     ms := 0;
              CLR       A
              MOV       ms, A
              MOV       ms+1, A

;     ms999 := 0;
              MOV       ms999, A
              MOV       ms999+1, A

;     s := 0;
              MOV       s, A
              MOV       s+1, A

;     usp := 0;
              MOV       usp, A
              MOV       usp+1, A

;     safe_mod := $55;
              MOV       $A1, #$55

;     safe_mod := $AA;
              MOV       $A1, #$AA

;     clock_cfg := {osc_en_int 24MHz} $86;
              MOV       $B9, #$86

;     safe_mod := 0;
              MOV       $A1, A

;     tmod := {t1_m=2 t0_m=1} $21;
              MOV       TMOD, #$21

;     tcon := {tr1 tr0} $50;
              MOV       TCON, #$50

; end.
              RET

RSEG _CONST


              END

